import { FluentOptionsInterface } from './fluent-options.interface';
export declare class FluentConnection {
    private readonly options?;
    static readonly DEFAULT_TAG_PREFIX = "logs";
    private fluentClient;
    private readonly hostname;
    constructor(options?: FluentOptionsInterface);
    private get fluentd();
    /**
     * Send log message to Fluent
     * @param message Message or Event that we send to Fluent destination
     * @param severity Severity of the log message
     * @param context Context for the message
     * @param stack Error stack (applicable for ERROR severity handling)
     * @private
     */
    emit(message: string | object, severity: string, context?: string, stack?: string): Promise<void>;
}
