"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var FluentConnection_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.FluentConnection = void 0;
const common_1 = require("@nestjs/common");
const logger_1 = require("@fluent-org/logger");
const os_1 = require("os");
let FluentConnection = FluentConnection_1 = class FluentConnection {
    constructor(options) {
        this.options = options;
        if (!this.options) {
            this.options = {};
        }
        if (!this.options.prefix) {
            this.options.prefix = FluentConnection_1.DEFAULT_TAG_PREFIX;
        }
        this.hostname = (0, os_1.hostname)();
    }
    get fluentd() {
        if (this.fluentClient) {
            return this.fluentClient;
        }
        return (this.fluentClient = new logger_1.FluentClient(this.options.prefix, this.options.connection));
    }
    /**
     * Send log message to Fluent
     * @param message Message or Event that we send to Fluent destination
     * @param severity Severity of the log message
     * @param context Context for the message
     * @param stack Error stack (applicable for ERROR severity handling)
     * @private
     */
    emit(message, severity, context, stack) {
        // prepare common payload
        const payload = {
            context,
            severity,
            hostname: this.hostname,
        };
        if (stack) {
            payload.stack = stack;
        }
        // send message
        if (typeof message === 'object') {
            return this.fluentd.emit(Object.assign(Object.assign({}, message), payload));
        }
        if (typeof message === 'string') {
            payload.message = message;
            return this.fluentd.emit(payload);
        }
        // handle unexpected message format
        throw new Error(`received message of unknown type [${typeof message}] ${message}`);
    }
};
FluentConnection.DEFAULT_TAG_PREFIX = 'logs';
FluentConnection = FluentConnection_1 = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Optional)()),
    __metadata("design:paramtypes", [Object])
], FluentConnection);
exports.FluentConnection = FluentConnection;
