import { LoggerService as LoggerInterface } from '@nestjs/common';
import { LoggerContextInterface } from './logger-context.interface';
import { FluentConnection } from './fluent-connection.service';
export declare class FluentLogger implements LoggerInterface, LoggerContextInterface {
    protected readonly fluent: FluentConnection;
    private context;
    constructor(fluent: FluentConnection);
    /**
     * Write a 'log' level log.
     */
    log(message: any, context?: string): Promise<void>;
    /**
     * Write a 'error' level log.
     */
    error(message: any, stack?: string, context?: string): Promise<void>;
    /**
     * Write a 'warn' level log.
     */
    warn(message: any, context?: string): Promise<void>;
    /**
     * Write a 'debug' level log.
     */
    debug(message: any, context?: string): Promise<void>;
    /**
     * Write a 'verbose' level log.
     */
    verbose(message: any, context?: string): Promise<void>;
    /**
     * Resets the logger context to the value that was passed in the constructor.
     */
    resetContext(): void;
    /**
     * Set logger context
     * @param context context
     */
    setContext(context: string): void;
}
