"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FluentLogger = void 0;
const common_1 = require("@nestjs/common");
const fluent_connection_service_1 = require("./fluent-connection.service");
let FluentLogger = class FluentLogger {
    constructor(fluent) {
        this.fluent = fluent;
    }
    /**
     * Write a 'log' level log.
     */
    log(message, context) {
        return this.fluent.emit(message, 'LOG', context ? context : this.context);
    }
    /**
     * Write a 'error' level log.
     */
    error(message, stack, context) {
        return this.fluent.emit(message, 'ERROR', context ? context : this.context, stack);
    }
    /**
     * Write a 'warn' level log.
     */
    warn(message, context) {
        return this.fluent.emit(message, 'WARN', context ? context : this.context);
    }
    /**
     * Write a 'debug' level log.
     */
    debug(message, context) {
        return this.fluent.emit(message, 'DEBUG', context ? context : this.context);
    }
    /**
     * Write a 'verbose' level log.
     */
    verbose(message, context) {
        return this.fluent.emit(message, 'VERBOSE', context ? context : this.context);
    }
    /**
     * Resets the logger context to the value that was passed in the constructor.
     */
    resetContext() {
        this.context = undefined;
    }
    /**
     * Set logger context
     * @param context context
     */
    setContext(context) {
        this.context = context;
    }
};
FluentLogger = __decorate([
    (0, common_1.Injectable)({ scope: common_1.Scope.TRANSIENT }),
    __metadata("design:paramtypes", [fluent_connection_service_1.FluentConnection])
], FluentLogger);
exports.FluentLogger = FluentLogger;
